// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesPacket.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'sensor_modulation_performance'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_modulation_performance__struct.hpp"
// Member 'misalignment'
#include "off_highway_premium_radar_sample_msgs/msg/detail/misalignment_packet__struct.hpp"
// Member 'interference_indicator'
#include "off_highway_premium_radar_sample_msgs/msg/detail/interference_indicator__struct.hpp"
// Member 'sensor_field_of_view'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_field_of_view__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LocationAttributesPacket_
{
  using Type = LocationAttributesPacket_<ContainerAllocator>;

  explicit LocationAttributesPacket_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_modulation_performance(_init),
    misalignment(_init),
    interference_indicator(_init),
    sensor_field_of_view(_init)
  {
    (void)_init;
  }

  explicit LocationAttributesPacket_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_modulation_performance(_alloc, _init),
    misalignment(_alloc, _init),
    interference_indicator(_alloc, _init),
    sensor_field_of_view(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _sensor_modulation_performance_type =
    off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>;
  _sensor_modulation_performance_type sensor_modulation_performance;
  using _misalignment_type =
    off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>;
  _misalignment_type misalignment;
  using _interference_indicator_type =
    off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>;
  _interference_indicator_type interference_indicator;
  using _sensor_field_of_view_type =
    off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>;
  _sensor_field_of_view_type sensor_field_of_view;

  // setters for named parameter idiom
  Type & set__sensor_modulation_performance(
    const off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> & _arg)
  {
    this->sensor_modulation_performance = _arg;
    return *this;
  }
  Type & set__misalignment(
    const off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> & _arg)
  {
    this->misalignment = _arg;
    return *this;
  }
  Type & set__interference_indicator(
    const off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> & _arg)
  {
    this->interference_indicator = _arg;
    return *this;
  }
  Type & set__sensor_field_of_view(
    const off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> & _arg)
  {
    this->sensor_field_of_view = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LocationAttributesPacket_ & other) const
  {
    if (this->sensor_modulation_performance != other.sensor_modulation_performance) {
      return false;
    }
    if (this->misalignment != other.misalignment) {
      return false;
    }
    if (this->interference_indicator != other.interference_indicator) {
      return false;
    }
    if (this->sensor_field_of_view != other.sensor_field_of_view) {
      return false;
    }
    return true;
  }
  bool operator!=(const LocationAttributesPacket_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LocationAttributesPacket_

// alias to use template instance with default allocator
using LocationAttributesPacket =
  off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__STRUCT_HPP_
