// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorFeedback.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_feedback__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'vehicle_time'
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__traits.hpp"
// Member 'measurement_cycle_sync_data'
#include "off_highway_premium_radar_sample_msgs/msg/detail/measurement_cycle_sync_data__traits.hpp"
// Member 'ego_vehicle_data'
#include "off_highway_premium_radar_sample_msgs/msg/detail/ego_vehicle_data__traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorFeedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: lgp_version
  {
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << ", ";
  }

  // member: vehicle_time
  {
    out << "vehicle_time: ";
    to_flow_style_yaml(msg.vehicle_time, out);
    out << ", ";
  }

  // member: measurement_cycle_sync_data
  {
    out << "measurement_cycle_sync_data: ";
    to_flow_style_yaml(msg.measurement_cycle_sync_data, out);
    out << ", ";
  }

  // member: time_sync_status
  {
    out << "time_sync_status: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sync_status, out);
    out << ", ";
  }

  // member: ego_vehicle_data
  {
    out << "ego_vehicle_data: ";
    to_flow_style_yaml(msg.ego_vehicle_data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorFeedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: lgp_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << "\n";
  }

  // member: vehicle_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vehicle_time:\n";
    to_block_style_yaml(msg.vehicle_time, out, indentation + 2);
  }

  // member: measurement_cycle_sync_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "measurement_cycle_sync_data:\n";
    to_block_style_yaml(msg.measurement_cycle_sync_data, out, indentation + 2);
  }

  // member: time_sync_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_sync_status: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sync_status, out);
    out << "\n";
  }

  // member: ego_vehicle_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ego_vehicle_data:\n";
    to_block_style_yaml(msg.ego_vehicle_data, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorFeedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorFeedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorFeedback & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorFeedback>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorFeedback";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorFeedback>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorFeedback";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorFeedback>
  : std::integral_constant<bool, has_fixed_size<off_highway_premium_radar_sample_msgs::msg::EgoVehicleData>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::Time>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorFeedback>
  : std::integral_constant<bool, has_bounded_size<off_highway_premium_radar_sample_msgs::msg::EgoVehicleData>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::Time>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorFeedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__TRAITS_HPP_
