// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/MisalignmentPacket.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/misalignment_packet__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MisalignmentPacket & msg,
  std::ostream & out)
{
  out << "{";
  // member: theta
  {
    out << "theta: ";
    rosidl_generator_traits::value_to_yaml(msg.theta, out);
    out << ", ";
  }

  // member: theta_variance
  {
    out << "theta_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_variance, out);
    out << ", ";
  }

  // member: phi
  {
    out << "phi: ";
    rosidl_generator_traits::value_to_yaml(msg.phi, out);
    out << ", ";
  }

  // member: phi_variance
  {
    out << "phi_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_variance, out);
    out << ", ";
  }

  // member: phi_eme
  {
    out << "phi_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_eme, out);
    out << ", ";
  }

  // member: phi_eme_variance
  {
    out << "phi_eme_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_eme_variance, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: status_eme
  {
    out << "status_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.status_eme, out);
    out << ", ";
  }

  // member: percent_negative_theta
  {
    out << "percent_negative_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.percent_negative_theta, out);
    out << ", ";
  }

  // member: min_theta_sos
  {
    out << "min_theta_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.min_theta_sos, out);
    out << ", ";
  }

  // member: max_theta_sos
  {
    out << "max_theta_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.max_theta_sos, out);
    out << ", ";
  }

  // member: theta_sos_variance
  {
    out << "theta_sos_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_sos_variance, out);
    out << ", ";
  }

  // member: theta_sos_mean
  {
    out << "theta_sos_mean: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_sos_mean, out);
    out << ", ";
  }

  // member: min_phi_sos
  {
    out << "min_phi_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.min_phi_sos, out);
    out << ", ";
  }

  // member: max_phi_sos
  {
    out << "max_phi_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.max_phi_sos, out);
    out << ", ";
  }

  // member: phi_sos_variance
  {
    out << "phi_sos_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_variance, out);
    out << ", ";
  }

  // member: phi_sos_mean
  {
    out << "phi_sos_mean: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_mean, out);
    out << ", ";
  }

  // member: phi_sos_spread
  {
    out << "phi_sos_spread: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_spread, out);
    out << ", ";
  }

  // member: num_sos
  {
    out << "num_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.num_sos, out);
    out << ", ";
  }

  // member: num_eme
  {
    out << "num_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.num_eme, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MisalignmentPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "theta: ";
    rosidl_generator_traits::value_to_yaml(msg.theta, out);
    out << "\n";
  }

  // member: theta_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "theta_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_variance, out);
    out << "\n";
  }

  // member: phi
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi: ";
    rosidl_generator_traits::value_to_yaml(msg.phi, out);
    out << "\n";
  }

  // member: phi_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_variance, out);
    out << "\n";
  }

  // member: phi_eme
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_eme, out);
    out << "\n";
  }

  // member: phi_eme_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_eme_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_eme_variance, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: status_eme
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.status_eme, out);
    out << "\n";
  }

  // member: percent_negative_theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "percent_negative_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.percent_negative_theta, out);
    out << "\n";
  }

  // member: min_theta_sos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_theta_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.min_theta_sos, out);
    out << "\n";
  }

  // member: max_theta_sos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_theta_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.max_theta_sos, out);
    out << "\n";
  }

  // member: theta_sos_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "theta_sos_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_sos_variance, out);
    out << "\n";
  }

  // member: theta_sos_mean
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "theta_sos_mean: ";
    rosidl_generator_traits::value_to_yaml(msg.theta_sos_mean, out);
    out << "\n";
  }

  // member: min_phi_sos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_phi_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.min_phi_sos, out);
    out << "\n";
  }

  // member: max_phi_sos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_phi_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.max_phi_sos, out);
    out << "\n";
  }

  // member: phi_sos_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_sos_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_variance, out);
    out << "\n";
  }

  // member: phi_sos_mean
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_sos_mean: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_mean, out);
    out << "\n";
  }

  // member: phi_sos_spread
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "phi_sos_spread: ";
    rosidl_generator_traits::value_to_yaml(msg.phi_sos_spread, out);
    out << "\n";
  }

  // member: num_sos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_sos: ";
    rosidl_generator_traits::value_to_yaml(msg.num_sos, out);
    out << "\n";
  }

  // member: num_eme
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_eme: ";
    rosidl_generator_traits::value_to_yaml(msg.num_eme, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MisalignmentPacket & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>()
{
  return "off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>()
{
  return "off_highway_premium_radar_sample_msgs/msg/MisalignmentPacket";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__TRAITS_HPP_
