// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorBroadcastData.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_broadcast_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'sensor_ethernet_configuration_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_ethernet_configuration_information__traits.hpp"
// Member 'diagnostics_ethernet_configuration_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/diagnostics_ethernet_configuration_information__traits.hpp"
// Member 'doip_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/do_ip_information__traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorBroadcastData & msg,
  std::ostream & out)
{
  out << "{";
  // member: customer_version
  {
    out << "customer_version: ";
    rosidl_generator_traits::value_to_yaml(msg.customer_version, out);
    out << ", ";
  }

  // member: sensor_ethernet_configuration_information
  {
    out << "sensor_ethernet_configuration_information: ";
    to_flow_style_yaml(msg.sensor_ethernet_configuration_information, out);
    out << ", ";
  }

  // member: diagnostics_ethernet_configuration_information
  {
    out << "diagnostics_ethernet_configuration_information: ";
    to_flow_style_yaml(msg.diagnostics_ethernet_configuration_information, out);
    out << ", ";
  }

  // member: sensor_mac_address
  {
    out << "sensor_mac_address: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_mac_address, out);
    out << ", ";
  }

  // member: doip_information
  {
    out << "doip_information: ";
    to_flow_style_yaml(msg.doip_information, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorBroadcastData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: customer_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "customer_version: ";
    rosidl_generator_traits::value_to_yaml(msg.customer_version, out);
    out << "\n";
  }

  // member: sensor_ethernet_configuration_information
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_ethernet_configuration_information:\n";
    to_block_style_yaml(msg.sensor_ethernet_configuration_information, out, indentation + 2);
  }

  // member: diagnostics_ethernet_configuration_information
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "diagnostics_ethernet_configuration_information:\n";
    to_block_style_yaml(msg.diagnostics_ethernet_configuration_information, out, indentation + 2);
  }

  // member: sensor_mac_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_mac_address: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_mac_address, out);
    out << "\n";
  }

  // member: doip_information
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "doip_information:\n";
    to_block_style_yaml(msg.doip_information, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorBroadcastData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorBroadcastData";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData>
  : std::integral_constant<bool, has_fixed_size<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>::value> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData>
  : std::integral_constant<bool, has_bounded_size<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>::value> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__TRAITS_HPP_
