// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorDtcInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_DTC_INFORMATION__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_DTC_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorDtcInformation __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorDtcInformation __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorDtcInformation_
{
  using Type = SensorDtcInformation_<ContainerAllocator>;

  explicit SensorDtcInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      std::fill<typename std::array<uint32_t, 10>::iterator, uint32_t>(this->dtcs.begin(), this->dtcs.end(), 0ul);
    }
  }

  explicit SensorDtcInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    dtcs(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      std::fill<typename std::array<uint32_t, 10>::iterator, uint32_t>(this->dtcs.begin(), this->dtcs.end(), 0ul);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _lgp_version_type =
    uint32_t;
  _lgp_version_type lgp_version;
  using _dtcs_type =
    std::array<uint32_t, 10>;
  _dtcs_type dtcs;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__lgp_version(
    const uint32_t & _arg)
  {
    this->lgp_version = _arg;
    return *this;
  }
  Type & set__dtcs(
    const std::array<uint32_t, 10> & _arg)
  {
    this->dtcs = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorDtcInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorDtcInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorDtcInformation_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->lgp_version != other.lgp_version) {
      return false;
    }
    if (this->dtcs != other.dtcs) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorDtcInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorDtcInformation_

// alias to use template instance with default allocator
using SensorDtcInformation =
  off_highway_premium_radar_sample_msgs::msg::SensorDtcInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_DTC_INFORMATION__STRUCT_HPP_
