// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorFieldOfView.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorFieldOfView_
{
  using Type = SensorFieldOfView_<ContainerAllocator>;

  explicit SensorFieldOfView_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 25>::iterator, float>(this->fov.begin(), this->fov.end(), 0.0f);
      std::fill<typename std::array<float, 25>::iterator, float>(this->azimuth.begin(), this->azimuth.end(), 0.0f);
      std::fill<typename std::array<float, 11>::iterator, float>(this->elevation_range_scaling.begin(), this->elevation_range_scaling.end(), 0.0f);
      std::fill<typename std::array<float, 11>::iterator, float>(this->elevation.begin(), this->elevation.end(), 0.0f);
    }
  }

  explicit SensorFieldOfView_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : fov(_alloc),
    azimuth(_alloc),
    elevation_range_scaling(_alloc),
    elevation(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 25>::iterator, float>(this->fov.begin(), this->fov.end(), 0.0f);
      std::fill<typename std::array<float, 25>::iterator, float>(this->azimuth.begin(), this->azimuth.end(), 0.0f);
      std::fill<typename std::array<float, 11>::iterator, float>(this->elevation_range_scaling.begin(), this->elevation_range_scaling.end(), 0.0f);
      std::fill<typename std::array<float, 11>::iterator, float>(this->elevation.begin(), this->elevation.end(), 0.0f);
    }
  }

  // field types and members
  using _fov_type =
    std::array<float, 25>;
  _fov_type fov;
  using _azimuth_type =
    std::array<float, 25>;
  _azimuth_type azimuth;
  using _elevation_range_scaling_type =
    std::array<float, 11>;
  _elevation_range_scaling_type elevation_range_scaling;
  using _elevation_type =
    std::array<float, 11>;
  _elevation_type elevation;

  // setters for named parameter idiom
  Type & set__fov(
    const std::array<float, 25> & _arg)
  {
    this->fov = _arg;
    return *this;
  }
  Type & set__azimuth(
    const std::array<float, 25> & _arg)
  {
    this->azimuth = _arg;
    return *this;
  }
  Type & set__elevation_range_scaling(
    const std::array<float, 11> & _arg)
  {
    this->elevation_range_scaling = _arg;
    return *this;
  }
  Type & set__elevation(
    const std::array<float, 11> & _arg)
  {
    this->elevation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorFieldOfView_ & other) const
  {
    if (this->fov != other.fov) {
      return false;
    }
    if (this->azimuth != other.azimuth) {
      return false;
    }
    if (this->elevation_range_scaling != other.elevation_range_scaling) {
      return false;
    }
    if (this->elevation != other.elevation) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorFieldOfView_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorFieldOfView_

// alias to use template instance with default allocator
using SensorFieldOfView =
  off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__STRUCT_HPP_
