// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorModulationPerformance.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_modulation_performance__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorModulationPerformance & msg,
  std::ostream & out)
{
  out << "{";
  // member: detection_of_measurement_program
  {
    out << "detection_of_measurement_program: ";
    rosidl_generator_traits::value_to_yaml(msg.detection_of_measurement_program, out);
    out << ", ";
  }

  // member: modulation_id
  {
    out << "modulation_id: ";
    rosidl_generator_traits::value_to_yaml(msg.modulation_id, out);
    out << ", ";
  }

  // member: distance_range_scaling
  {
    out << "distance_range_scaling: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_range_scaling, out);
    out << ", ";
  }

  // member: separability_distance
  {
    out << "separability_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.separability_distance, out);
    out << ", ";
  }

  // member: separability_relative_velocity
  {
    out << "separability_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.separability_relative_velocity, out);
    out << ", ";
  }

  // member: precision_distance
  {
    out << "precision_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.precision_distance, out);
    out << ", ";
  }

  // member: precision_relative_velocity
  {
    out << "precision_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.precision_relative_velocity, out);
    out << ", ";
  }

  // member: covariance_of_distance_and_relative_velocity
  {
    out << "covariance_of_distance_and_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.covariance_of_distance_and_relative_velocity, out);
    out << ", ";
  }

  // member: minimum_measurable_distance
  {
    out << "minimum_measurable_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.minimum_measurable_distance, out);
    out << ", ";
  }

  // member: maximum_measurable_distance
  {
    out << "maximum_measurable_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.maximum_measurable_distance, out);
    out << ", ";
  }

  // member: minimum_measurable_relative_velocity
  {
    out << "minimum_measurable_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.minimum_measurable_relative_velocity, out);
    out << ", ";
  }

  // member: maximum_measurable_relative_velocity
  {
    out << "maximum_measurable_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.maximum_measurable_relative_velocity, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorModulationPerformance & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: detection_of_measurement_program
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detection_of_measurement_program: ";
    rosidl_generator_traits::value_to_yaml(msg.detection_of_measurement_program, out);
    out << "\n";
  }

  // member: modulation_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "modulation_id: ";
    rosidl_generator_traits::value_to_yaml(msg.modulation_id, out);
    out << "\n";
  }

  // member: distance_range_scaling
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_range_scaling: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_range_scaling, out);
    out << "\n";
  }

  // member: separability_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "separability_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.separability_distance, out);
    out << "\n";
  }

  // member: separability_relative_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "separability_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.separability_relative_velocity, out);
    out << "\n";
  }

  // member: precision_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "precision_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.precision_distance, out);
    out << "\n";
  }

  // member: precision_relative_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "precision_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.precision_relative_velocity, out);
    out << "\n";
  }

  // member: covariance_of_distance_and_relative_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "covariance_of_distance_and_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.covariance_of_distance_and_relative_velocity, out);
    out << "\n";
  }

  // member: minimum_measurable_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "minimum_measurable_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.minimum_measurable_distance, out);
    out << "\n";
  }

  // member: maximum_measurable_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maximum_measurable_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.maximum_measurable_distance, out);
    out << "\n";
  }

  // member: minimum_measurable_relative_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "minimum_measurable_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.minimum_measurable_relative_velocity, out);
    out << "\n";
  }

  // member: maximum_measurable_relative_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maximum_measurable_relative_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.maximum_measurable_relative_velocity, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorModulationPerformance & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorModulationPerformance";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__TRAITS_HPP_
